/*
 * trace-tools - A library and a set of tools to manipulate wireless traces.
 * Copyright (C) 2007  Universite Pierre et Marie Curie - Paris 6
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA  02110-1301  USA
 *
 * Author: Thomas Claveirole <thomas.claveirole@lip6.fr>
 */
#ifndef PCAP_TYPEDEFS_HH_
# define PCAP_TYPEDEFS_HH_

# include <trace-tools/pcap/pkthdr.hh>

namespace pcapxx
{

  /**
   * Callback function that handle a single frame/packet.
   *
   * @param[in,out]  user	User data.
   * @param[in]      h		The frame's PCAP header.
   * @param[in]      bytes	The frame's content.
   */
  typedef void	(*handler)(void* user, const pkthdr* h, const void* bytes);

} // End of namespace pcapxx.

#endif // ! PCAP_TYPEDEFS_HH_
