/*
 * trace-tools - A library and a set of tools to manipulate wireless traces.
 * Copyright (C) 2007  Universite Pierre et Marie Curie - Paris 6
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA  02110-1301  USA
 *
 * Author: Thomas Claveirole <thomas.claveirole@lip6.fr>
 */
#ifndef TOOL_ITERATOR_BASE_HXX_
# define TOOL_ITERATOR_BASE_HXX_

# include "iterator_base.hh"

namespace tool
{

  template <class B>
  iterator_base<B>::iterator_base(iterable_type& i, bool end): i_ (&i), v_ ()
  {
    if (not end)
      ++(*this);
  }

  template <class B>
  iterator_base<B>::~iterator_base()
  {
  }

  template <class B>
  bool
  iterator_base<B>::equal(const iterator_base& rhs) const
  {
    return i_ == rhs.i_ and v_ == rhs.v_;
  }

  template <class B>
  const typename iterator_base<B>::value_type&
  iterator_base<B>::get() const
  {
    return v_.get();
  }

  template <class B>
  const typename iterator_base<B>::value_type*
  iterator_base<B>::get_ptr() const
  {
    return v_.get_ptr();
  }

} // End of namespace tool.

#endif // ! TOOL_ITERATOR_BASE_HXX_
